
public class Engine {
	private int[][] tabla;
	private int potez;

	public Engine() {
		__init__();
	}

	public void __init__() {
		potez = 1;
		tabla = new int[3][3];
		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 3; j++) {
				tabla[i][j] = 0;
			}
		}
	}

	public void odigrajPotez(int i, int j) {
		if (tabla[i][j] == 0) {
			if (potez == 1) {
				postaviX(i, j);
				potez = -1;
			} else {
				postaviO(i, j);
				potez = 1;
			}
		} else
			System.err.println("Zauzeto polje.");
	}

	public void postaviX(int i, int j) {
		tabla[i][j] = 1;
	}

	public void postaviO(int i, int j) {
		tabla[i][j] = -1;
	}

	private int check() {
		boolean nereseno = true;
		int sumGlavne = 0, sumSporedne = 0;
		int sumKolone = 0, sumVrste = 0;

		for (int i = 0; i < 3; i++) {
			sumGlavne += tabla[i][i];
			sumSporedne += tabla[i][2 - i];

			sumKolone = 0;
			sumVrste = 0;
			for (int j = 0; j < 3; j++) {
				sumKolone += tabla[j][i];
				sumVrste += tabla[i][j];
				if (tabla[i][j] == 0)
					nereseno = false;
			}

			if (sumKolone == 3 || sumVrste == 3)
				return 1;
			else if (sumKolone == -3 || sumVrste == -3)
				return -1;
		}

		if (sumGlavne == 3 || sumSporedne == 3)
			return 1;
		else if (sumGlavne == -3 || sumSporedne == -3)
			return -1;

		if (nereseno)
			return 0;
		else
			return 2;
	}

	public String pobednik() {
		int pobednik = check();

		if (pobednik == 1) {
			System.out.println("Pobednik 1.");
			return "X";
		} else if (pobednik == -1) {
			System.out.println("Pobednik 0.");
			return "O";
		} else if (pobednik == 0) {
			System.out.println("Nereseno.");
			return "N";
		} else if (pobednik == 2) {
			System.out.println("Igra se nastavlja.");
			return "";
		} else
			return null;
	}

	public String dajSimbol(int i, int j) {
		if (tabla[i][j] == 1)
			return "X";
		if (tabla[i][j] == -1)
			return "O";
		return null;
	}

	public String koJeNaPotezu() {
		if (potez == 1)
			return "X";
		else
			return "O";
	}
}
