import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class UI extends JFrame {
	private static final long serialVersionUID = 1L;
	static JFrame window = new JFrame("Tic Tac Toe");
	Engine game = new Engine();
	Dugme[][] buttons = new Dugme[3][3];
	JLabel naPotezu = new JLabel("Na potezu je: X");

	public UI() {
		setMainWindow();
		setLabel();
		setMatrix();
		setRestart();
		pack();
	}

	private void setRestart() {
		// TODO Auto-generated method stub
		JPanel panel = new JPanel();
		JButton button = new JButton("Restart");

		button.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				System.out.println("Restart.");
				game.__init__();
				refreshGUI();
			}
		});

		panel.add(button, BorderLayout.CENTER);
		window.getContentPane().add(panel);
		pack();
	}

	private void setMatrix() {
		// TODO Auto-generated method stub
		JPanel panel = new JPanel();
		panel.setLayout(new FlowLayout());
		Container cont = new Container();
		cont.setLayout(new GridLayout(3, 3));

		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 3; j++) {
				buttons[i][j] = new Dugme(i, j);
				buttons[i][j].setPreferredSize(new Dimension(90, 30));
				buttons[i][j].addActionListener(new ActionListener() {
					@Override
					public void actionPerformed(ActionEvent e) {
						Dugme d = (Dugme) e.getSource();
						int x = d.getX();
						int y = d.getY();

						game.odigrajPotez(x, y);
						refreshGUI();
					}
				});
				cont.add(buttons[i][j]);
			}
		}
		panel.add(cont);
		window.getContentPane().add(panel);
		pack();
	}

	protected void refreshGUI() {
		// TODO Auto-generated method stub
		naPotezu.setText("Na potezu je: " + game.koJeNaPotezu());
		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 3; j++) {
				buttons[i][j].setText(game.dajSimbol(i, j));
			}
		}

		int odgovor;
		if (game.pobednik().equals("X") || game.pobednik().equals("O")) {
			odgovor = JOptionPane.showConfirmDialog(this, "Pobednik je " + game.pobednik() + "\nNova igra?",
					"Kraj igre", JOptionPane.YES_NO_OPTION);

			if (odgovor == JOptionPane.YES_OPTION) {
				game.__init__();
				refreshGUI();
			} else
				System.exit(0);
		} else if (game.pobednik().equals("N")) {
			odgovor = JOptionPane.showConfirmDialog(this, "Nereseno." + "\nNova igra?", "Kraj igre.",
					JOptionPane.YES_NO_OPTION);

			if (odgovor == JOptionPane.YES_OPTION) {
				game.__init__();
				refreshGUI();
			} else
				System.exit(0);
		}
	}

	private void setLabel() {
		// TODO Auto-generated method stub
		JPanel panel = new JPanel();
		panel.add(naPotezu, BorderLayout.CENTER);
		window.getContentPane().add(panel);
		pack();
	}

	private void setMainWindow() {
		// TODO Auto-generated method stub
		Toolkit tool = window.getToolkit();
		Dimension windowSize = tool.getScreenSize();
		window.setBounds(windowSize.width / 4, windowSize.height / 4, windowSize.width / 2, windowSize.height / 2);
		window.setSize(400, 400);
		window.getContentPane().setLayout(new GridLayout(3, 1));
		window.setVisible(true);
		window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

}
